program animals;
uses
  crt,dos;
type
  zeiger = ^knoten;
  knoten = record
             inhalt: string;
             ja,nein: zeiger;
           end;
var
  anker: zeiger;
  ch: char;
  dateiname: string;

procedure neu(var stelle:zeiger; inhalt:string);
begin
  new(stelle);
  stelle^.inhalt:=inhalt;
  stelle^.ja:=nil;
  stelle^.nein:=nil;
end;

procedure init;
begin
  new(anker);
  anker^.inhalt:='Hat es Federn?';
  neu(anker^.ja,'Ente');
  neu(anker^.nein,'Schwein');
end;

procedure spiel;
var
  stelle: zeiger;
  zeichen: char;
  weiter: boolean;
  eingabe,alttier: string;
begin
  stelle:=anker;
  writeln;
  writeln('Denk'' Dir ein Tier aus, ich errate es!');
  repeat
    if stelle^.ja=nil then
    begin
      writeln('Dann ist es ein(e) ',stelle^.inhalt,'!');
      write('Stimmt das(j,n)? ');
      zeichen:=readkey;
      writeln(zeichen);
      if zeichen='j' then
      begin
        writeln('Schn...');
        zeichen:=char(27);
      end;
      if zeichen='n' then
      begin
        alttier:=stelle^.inhalt;
        write('Dann sag'' mir was es ist: Es ist ein(e) ');
        readln(eingabe);
        writeln('Unterschied ''',eingabe,'''',char(29),'''',alttier,'''(z.B.:''Hat es drei Beine?'')?');
        readln(stelle^.inhalt);
        write(eingabe,': ',stelle^.inhalt,' (j,n) ');
        repeat
          weiter:=true;
          zeichen:= readkey;
          writeln(zeichen);
           case zeichen of
            'j': begin
                   neu(stelle^.ja,eingabe);
                   neu(stelle^.nein,alttier);
                 end;
            'n': begin
                   neu(stelle^.nein,eingabe);
                   neu(stelle^.ja,alttier);
                 end;
            char(27): writeln('Abbruch durch Benutzer!');
            else
            begin
              write('''j'' oder ''n''!?! Das ist jetzt ''ne Entscheidungsfrage! ');
              weiter:=false;
            end;
          end;
        until weiter;
        if zeichen<>char(27) then writeln('Tier gelernt!');
        zeichen:=char(27);
      end;
    end
    else
    repeat
      write(stelle^.inhalt,' (j,n) ');
      zeichen:=readkey;
      writeln(zeichen);
      weiter:=true;
      case zeichen of
        'j': stelle:=stelle^.ja;
        'n': stelle:=stelle^.nein;
        char(27): writeln('Abgebrochen!');
        else
        begin
            writeln('''j'' oder ''n''! Ist denn das so schwer? ');
            weiter:=false;
        end;
      end;
    until weiter;
  until zeichen=char(27);
end;

function oeffnen(dateiname:string):boolean;
var
  datei: text;
  anzahl: word;
  procedure lese(var element:zeiger);
  var
    i: byte;
  begin
    new(element);
    readln(datei,element^.inhalt);
    if element^.inhalt[length(element^.inhalt)]=char(2) then
    begin
      inc(anzahl);
      delete(element^.inhalt,length(element^.inhalt),1);
      element^.ja:=nil;
      element^.nein:=nil;
    end
    else
    begin
      lese(element^.ja);
      lese(element^.nein);
    end;
  end;
begin
  assign(datei,dateiname);
  {$i-}
  reset(datei);
  {$i+}
  if ioresult<>0 then
  begin
    oeffnen:=false;
    writeln('Datei ''',dateiname,''' nicht gefunden, starte neu!');
  end
  else
  begin
    oeffnen:=true;
    anzahl:=0;
    lese(anker);
    close(datei);
    writeln('Datei ''',dateiname,''' geffnet: ',anzahl,' Elemente!');
  end;
end;

procedure speichern(dateiname:string);
var
  datei: text;
  procedure schreibe(element:zeiger);
  begin
    write(datei,element^.inhalt);
    if element^.ja=nil then writeln(datei,char(2)) else
    begin
      writeln(datei,'');
      schreibe(element^.ja);
      schreibe(element^.nein);
    end;
  end;
begin
  assign(datei,dateiname);
  rewrite(datei);
  schreibe(anker);
  close(datei);
  writeln('Daten gespeichert!');
end;

procedure kriegeName;
begin
  if paramstr(1)='' then dateiname:='animals.van' else dateiname:=paramstr(1);
  if ((dateiname[1]='"')and(dateiname[length(dateiname)]='"')) then
  begin
    delete(dateiname,1,1);
    delete(dateiname,length(dateiname),1);
  end;
end;

begin
  clrscr;
  writeln('A N I M A L S',^j);
  kriegeName;
  if not(oeffnen(dateiname)) then init;
  repeat
    spiel;
    write('Esc = Ende     AndereTaste=Weiter');
    ch:=readkey;
    writeln;
  until ch=char(27);
  speichern(dateiname);
end.